#ifndef __COMMANDS_H
#define __COMMANDS_H

#define STOPROTATE( mode ) { di(); stoprotate( mode ); ei(); }
#define STARTROTATE_CW() { di(); startrotate_cw(); ei(); }
#define STARTROTATE_CCW() { di(); startrotate_ccw(); ei(); }

// -1 char because of the tailing 0
#define SAVEDPOSNAMELENGTH 14

// format of data stored in eeprom
typedef struct {
	int pos;
	char name[SAVEDPOSNAMELENGTH];
} savedpos_t;

#define SAVEDPOSBANKCOUNT _EEPROMSIZE / sizeof( savedpos_t )
#define ERR_NOSUCHBANK 0xff

void putpos( void );
void stoprotate( char silent );
void startrotate_cw( void );
void startrotate_ccw( void );
void printversion( void );
void printhelp( void );
char loadpos( char eprpos, savedpos_t* savedpos );
void savepos( unsigned int pos, char* name );
void erasepos( char* in );
void listsavedpositions( void );
void rotatetopos( char* in );

#endif
