#include <pic.h>
#include <limits.h>

#include "main.h"
#include "serial.h"
#include "delay/delay.h"
#include "delay/delay_alternative_enhanced_precision.h"

#if UINT_MAX >= 100000
#error This code supports 'int' less than 100000 only.
#endif

extern char ledflashcount;

void putch( char c ) {
	ledflashcount = COMMLEDFLASHCOUNT;

	while(!TXIF) { // set when register is empty
		clearUSARTErrors;
		CLRWDT();
	}
	TXREG = c;
	//DelayUs( 60 );
	while( !TRMT ) {}
}

unsigned char getch( void ) {
	ledflashcount = COMMLEDFLASHCOUNT;
	
	while(!RCIF)
	{
		CLRWDT();
		clearUSARTErrors;
	}
	return RCREG;
}

void puts( register const char* str ) {
	while( (*str) != 0 ) {
		putch( *str );
		str++;
	}
}

void initserialcomm( void ) {
	SPBRG = 12; // baud rate = 19.2k
	BRGH = 1; // high speed on
	SPEN = 1; // serial port enable
	CREN = 1; // continuous receive enable
	TXEN = 1; // tx enable

	dummy = RCREG; // clearing RX reg
}
